#ifndef EP11SHIELD_H
#define EP11SHIELD_H

// include Arduino headers
#include "Arduino.h"

#define EP11SHIELD_DAC_DDR		DDRD
#define EP11SHIELD_DAC_PORT		PORTD
#define EP11SHIELD_DAC_MASK		0x3F
#define EP11SHIELD_DAC_SHIFT	2
#define EP11SHIELD_PWM_PIN		10
#define EP11SHIELD_COMP_PIN		9
#define EP11SHIELD_ICP_PIN		8
#define EP11SHIELD_ADC_PIN		A0


class EP11Shield {
	public:
		static void begin();
		static void end();
		static void DACwrite(uint8_t value);
		static int COMPread();
		static uint32_t FREQread(unsigned long gatetime = 1000);
		static uint32_t PULSEread();
		static inline void captureISR();

	protected:
		volatile static uint32_t m_freqcnt;
};

#endif // EP11SHIELD_H
